diff -urN -X diff-exclude.txt /var/tmp/ax7z_src-orig/00am.vcxproj.filters ./00am.vcxproj.filters
--- /var/tmp/ax7z_src-orig/00am.vcxproj.filters	1970-01-01 09:00:00.000000000 +0900
+++ ./00am.vcxproj.filters	2015-01-09 00:41:22.351848800 +0900
@@ -0,0 +1,253 @@
+ï»¿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="4.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <ItemGroup>
+    <Filter Include="Source Files">
+      <UniqueIdentifier>{1a96980a-a03d-4668-8860-37aa154d89dc}</UniqueIdentifier>
+      <Extensions>cpp;c;cxx;rc;def;r;odl;idl;hpj;bat</Extensions>
+    </Filter>
+    <Filter Include="Header Files">
+      <UniqueIdentifier>{a24b5a2c-f87e-4506-b293-cbd4225e91c8}</UniqueIdentifier>
+      <Extensions>h;hpp;hxx;hm;inl</Extensions>
+    </Filter>
+    <Filter Include="7-zip">
+      <UniqueIdentifier>{c22458e7-7223-4e81-bafc-eeebda33ce82}</UniqueIdentifier>
+    </Filter>
+    <Filter Include="7-zip\Common">
+      <UniqueIdentifier>{261cec54-8ae9-4e70-b362-6f6156c839c8}</UniqueIdentifier>
+    </Filter>
+    <Filter Include="7-zip\bridge">
+      <UniqueIdentifier>{a176f517-0023-4015-9202-2e24e81305ff}</UniqueIdentifier>
+    </Filter>
+    <Filter Include="7-zip\7-zip Common">
+      <UniqueIdentifier>{b6f8533a-d893-47eb-b9fb-a8a86609c854}</UniqueIdentifier>
+    </Filter>
+    <Filter Include="7-zip\Windows">
+      <UniqueIdentifier>{eb818b1b-32cb-4ab5-ac05-e92ed3c33631}</UniqueIdentifier>
+    </Filter>
+    <Filter Include="7-zip\UI Common">
+      <UniqueIdentifier>{08784d0c-10b8-4903-84aa-ccc39ea26c47}</UniqueIdentifier>
+    </Filter>
+    <Filter Include="Resource Files">
+      <UniqueIdentifier>{09374d5a-8ff3-45a5-858d-f651e6e22f79}</UniqueIdentifier>
+      <Extensions>ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe</Extensions>
+    </Filter>
+    <Filter Include="sqlite3">
+      <UniqueIdentifier>{1c076c8e-2708-48ae-aa5b-3c508db1d41e}</UniqueIdentifier>
+    </Filter>
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="ax7z.def">
+      <Filter>Source Files</Filter>
+    </None>
+  </ItemGroup>
+  <ItemGroup>
+    <ResourceCompile Include="ax7z.rc">
+      <Filter>Source Files</Filter>
+    </ResourceCompile>
+  </ItemGroup>
+  <ItemGroup>
+    <ClCompile Include="entryFuncs.cpp">
+      <Filter>Source Files</Filter>
+    </ClCompile>
+    <ClCompile Include="infcache.cpp">
+      <Filter>Source Files</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\Common\IntToString.cpp">
+      <Filter>7-zip\Common</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\common\MyString.cpp">
+      <Filter>7-zip\Common</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\common\MyVector.cpp">
+      <Filter>7-zip\Common</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\Common\StdInStream.cpp">
+      <Filter>7-zip\Common</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\Common\StdOutStream.cpp">
+      <Filter>7-zip\Common</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\7zip\Common\StreamUtils.cpp">
+      <Filter>7-zip\Common</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\Common\StringConvert.cpp">
+      <Filter>7-zip\Common</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\Common\StringToInt.cpp">
+      <Filter>7-zip\Common</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\Common\Wildcard.cpp">
+      <Filter>7-zip\Common</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\7zip\Bundles\ax7z\bridge.cpp">
+      <Filter>7-zip\bridge</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\7zip\Bundles\ax7z\ExtractCallback.cpp">
+      <Filter>7-zip\bridge</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\7zip\Bundles\ax7z\OpenCallback.cpp">
+      <Filter>7-zip\bridge</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\7zip\Bundles\ax7z\PasswordManager.cpp">
+      <Filter>7-zip\bridge</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\7zip\Bundles\ax7z\SolidArchiveExtractCallback.cpp">
+      <Filter>7-zip\bridge</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\7zip\Bundles\ax7z\SolidCache.cpp">
+      <Filter>7-zip\bridge</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\7zip\Bundles\ax7z\SolidCacheDisk.cpp">
+      <Filter>7-zip\bridge</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\7zip\Common\FileStreams.cpp">
+      <Filter>7-zip\7-zip Common</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\Windows\DLL.cpp">
+      <Filter>7-zip\Windows</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\Windows\FileDir.cpp">
+      <Filter>7-zip\Windows</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\Windows\FileFind.cpp">
+      <Filter>7-zip\Windows</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\Windows\FileIO.cpp">
+      <Filter>7-zip\Windows</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\Windows\FileName.cpp">
+      <Filter>7-zip\Windows</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\Windows\PropVariant.cpp">
+      <Filter>7-zip\Windows</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\Windows\PropVariantConversions.cpp">
+      <Filter>7-zip\Windows</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\Windows\Registry.cpp">
+      <Filter>7-zip\Windows</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\7zip\Ui\Common\ArchiveOpenCallback.cpp">
+      <Filter>7-zip\UI Common</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\7zip\Ui\Common\DefaultName.cpp">
+      <Filter>7-zip\UI Common</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\7zip\ui\common\LoadCodecs.cpp">
+      <Filter>7-zip\UI Common</Filter>
+    </ClCompile>
+    <ClCompile Include="7z\7zip\Ui\Common\OpenArchive.cpp">
+      <Filter>7-zip\UI Common</Filter>
+    </ClCompile>
+    <ClCompile Include="sqlite3\sqlite3.c">
+      <Filter>sqlite3</Filter>
+    </ClCompile>
+  </ItemGroup>
+  <ItemGroup>
+    <ClInclude Include="critsect.h">
+      <Filter>Header Files</Filter>
+    </ClInclude>
+    <ClInclude Include="entryFuncs.h">
+      <Filter>Header Files</Filter>
+    </ClInclude>
+    <ClInclude Include="infcache.h">
+      <Filter>Header Files</Filter>
+    </ClInclude>
+    <ClInclude Include="resource.h">
+      <Filter>Header Files</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\Common\IntToString.h">
+      <Filter>7-zip\Common</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\Common\MyCom.h">
+      <Filter>7-zip\Common</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\common\MyString.h">
+      <Filter>7-zip\Common</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\common\MyVector.h">
+      <Filter>7-zip\Common</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\Common\StdInStream.h">
+      <Filter>7-zip\Common</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\Common\StdOutStream.h">
+      <Filter>7-zip\Common</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\7zip\Common\StreamUtils.h">
+      <Filter>7-zip\Common</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\Common\StringConvert.h">
+      <Filter>7-zip\Common</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\Common\StringToInt.h">
+      <Filter>7-zip\Common</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\Common\Wildcard.h">
+      <Filter>7-zip\Common</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\7zip\Bundles\ax7z\ExtractCallback.h">
+      <Filter>7-zip\bridge</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\7zip\Bundles\ax7z\OpenCallback.h">
+      <Filter>7-zip\bridge</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\7zip\Bundles\ax7z\PasswordManager.h">
+      <Filter>7-zip\bridge</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\7zip\Bundles\ax7z\SolidArchiveExtractCallback.h">
+      <Filter>7-zip\bridge</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\7zip\Bundles\ax7z\SolidCache.h">
+      <Filter>7-zip\bridge</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\7zip\Common\FileStreams.h">
+      <Filter>7-zip\7-zip Common</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\Windows\DLL.h">
+      <Filter>7-zip\Windows</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\Windows\FileDir.h">
+      <Filter>7-zip\Windows</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\Windows\FileFind.h">
+      <Filter>7-zip\Windows</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\Windows\FileIO.h">
+      <Filter>7-zip\Windows</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\Windows\FileName.h">
+      <Filter>7-zip\Windows</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\Windows\PropVariant.h">
+      <Filter>7-zip\Windows</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\Windows\PropVariantConversions.h">
+      <Filter>7-zip\Windows</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\Windows\Registry.h">
+      <Filter>7-zip\Windows</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\7zip\Ui\Common\ArchiveOpenCallback.h">
+      <Filter>7-zip\UI Common</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\7zip\Ui\Common\DefaultName.h">
+      <Filter>7-zip\UI Common</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\7zip\ui\common\LoadCodecs.h">
+      <Filter>7-zip\UI Common</Filter>
+    </ClInclude>
+    <ClInclude Include="7z\7zip\Ui\Common\OpenArchive.h">
+      <Filter>7-zip\UI Common</Filter>
+    </ClInclude>
+    <ClInclude Include="sqlite3\sqlite3.h">
+      <Filter>sqlite3</Filter>
+    </ClInclude>
+    <ClInclude Include="sqlite3\sqlite3helper.h">
+      <Filter>sqlite3</Filter>
+    </ClInclude>
+  </ItemGroup>
+  <ItemGroup>
+    <Text Include="ax7z.txt" />
+  </ItemGroup>
+</Project>
\ No newline at end of file
diff -urN -X diff-exclude.txt /var/tmp/ax7z_src-orig/7z/7zip/Bundles/ax7z/ExtractCallback.cpp ./7z/7zip/Bundles/ax7z/ExtractCallback.cpp
--- /var/tmp/ax7z_src-orig/7z/7zip/Bundles/ax7z/ExtractCallback.cpp	2005-09-26 00:48:18.000000000 +0900
+++ ./7z/7zip/Bundles/ax7z/ExtractCallback.cpp	2015-01-09 00:41:22.355849200 +0900
@@ -1,6 +1,9 @@
 // ExtractCallback.h
+#define NOMINMAX
 #include <windows.h>
+#undef NOMINMAX
 #include "ExtractCallback.h"
+#include "PasswordManager.h"
 #include "Common/StringConvert.h"
 #include "Windows/FileDir.h"
 #include "Windows/PropVariant.h"
@@ -9,7 +12,7 @@
 
 using namespace NWindows;
 
-void CExtractCallbackImp::Init(IInArchive *archive, char* pBuf, UINT32 nBufSize, FILE* fp, UINT32 index)
+void CExtractCallbackImp::Init(IInArchive *archive, char** pBuf, UINT32 nBufSize, FILE* fp, UINT32 index, SolidFileCache *cache, SPI_PROGRESS lpPrgressCallback, long lData)
 {
   assert(!pBuf || !fp);
   m_NumErrors = 0;
@@ -18,6 +21,10 @@
   m_fp = fp;
   m_nBufSize = nBufSize;
   m_nIndex = index;
+  m_nCurIndex = 0xFFFFFFFF;
+  m_cache = cache;
+  m_lpPrgressCallback = lpPrgressCallback;
+  m_lData = lData;
 }
 
 bool CExtractCallbackImp::IsEncrypted(UINT32 index)
@@ -46,38 +53,63 @@
 {
 public:
     CMemOutStream() : m_iPos(0), m_pBuf(NULL), m_nBufSize(0) {}
-    void Init(char* pBuf, UINT32 nBufSize, FILE* fp, bool bValid) { m_pBuf = pBuf; m_fp = fp; m_nBufSize = nBufSize; m_bValid = bValid; }
+    void Init(char** pBuf, UINT32 nBufSize, FILE* fp, bool bValid, SolidFileCache *cache, UINT32 nIndex)
+	{
+		m_pBuf = pBuf;
+		m_fp = fp;
+		m_nBufSize = nBufSize;
+		m_bValid = bValid;
+		m_cache = cache;
+		m_index = nIndex;
+		m_bIsSizeUnspecified = (nBufSize == 0);
+	}
   MY_UNKNOWN_IMP
 
   STDMETHOD(Write)(const void *data, UINT32 size, UINT32 *processedSize);
   STDMETHOD(WritePart)(const void *data, UINT32 size, UINT32 *processedSize);
 protected:
     UINT32 m_iPos;
-    char* m_pBuf;
+    char** m_pBuf;
     FILE* m_fp;
     UINT32 m_nBufSize;
     bool m_bValid;
+	SolidFileCache *m_cache;
+	UINT32 m_index;
+    bool m_bIsSizeUnspecified;
 };
 
 STDMETHODIMP CMemOutStream::Write(const void *data, UINT32 size, UINT32 *processedSize)
 {
-    if (!m_bValid) {
-        *processedSize = size;
-        return S_OK;
-    }
-
     UINT32 dummy;
     if (processedSize == NULL) {
         processedSize = &dummy;
     }
     
+    if(m_cache && !m_cache->IsCached(m_index)) m_cache->Append(m_index, data, size);
+
+    if (!m_bValid) {
+        *processedSize = size;
+        return S_OK;
+    }
+
     if (m_nBufSize < m_iPos + size) {
-        // ”O‚Ì‚½‚ßƒ`ƒFƒbƒN
-        return S_FALSE;
+		if(m_bIsSizeUnspecified) {
+			// Extend buffer
+			if(m_pBuf) {
+				char *pBuf = (char*)LocalAlloc(LMEM_FIXED, static_cast<size_t>(m_iPos + size));
+				if(!pBuf) return S_FALSE;
+				CopyMemory(pBuf, *m_pBuf, m_iPos);
+				LocalFree(*m_pBuf);
+				*m_pBuf = pBuf;
+			}
+		} else {
+			// ”O‚Ì‚½‚ßƒ`ƒFƒbƒN
+			return S_FALSE;
+		}
     }
 
     if (m_pBuf) {
-        memcpy(m_pBuf + m_iPos, data, size);
+        memcpy(*m_pBuf + m_iPos, data, size);
     } else {
         fwrite(data, size, 1, m_fp);
     }
@@ -94,10 +126,15 @@
 STDMETHODIMP CExtractCallbackImp::GetStream(UINT32 index,
     ISequentialOutStream **outStream, INT32 askExtractMode)
 {
+    m_nCurIndex = index;
     CMemOutStream* pRealStream = new CMemOutStream;
     pRealStream->AddRef();
-    pRealStream->Init(m_pBuf, m_nBufSize, m_fp, index == m_nIndex);
+    pRealStream->Init(m_pBuf, m_nBufSize, m_fp, index == m_nIndex, m_cache, index);
     *outStream = pRealStream;
+// TODO: support abort?
+	if(m_lpPrgressCallback && m_cache)
+		if(m_lpPrgressCallback(m_cache->GetProgress(index), m_cache->GetProgressDenom(index), m_lData))
+			return E_ABORT;
     return S_OK;
 }
 
@@ -112,7 +149,16 @@
   {
     case NArchive::NExtract::NOperationResult::kOK:
     {
-      break;
+	  if(m_cache) {
+		m_cache->Cached(m_nCurIndex);
+		boost::this_thread::yield();
+	  }
+	  break;
+    }
+    case NArchive::NExtract::NOperationResult::kDataError:
+    case NArchive::NExtract::NOperationResult::kCRCError:
+    {
+      PasswordManager::Get().NotifyError();
     }
     default:
     {
@@ -124,17 +170,10 @@
 
 STDMETHODIMP CExtractCallbackImp::CryptoGetTextPassword(BSTR *password)
 {
-  /*
-  if (!m_PasswordIsDefined)
-  {
-    g_StdOut << "\nEnter password:";
-    AString oemPassword = g_StdIn.ScanStringUntilNewLine();
-    m_Password = MultiByteToUnicodeString(oemPassword, CP_OEMCP); 
-    m_PasswordIsDefined = true;
-  }
-  CMyComBSTR tempName(m_Password);
+  UString usPassword = PasswordManager::Get().GetPassword(false);
+  CMyComBSTR tempName(usPassword);
   *password = tempName.Detach();
-  */
+
   return S_OK;
 }
   
diff -urN -X diff-exclude.txt /var/tmp/ax7z_src-orig/7z/7zip/Bundles/ax7z/ExtractCallback.h ./7z/7zip/Bundles/ax7z/ExtractCallback.h
--- /var/tmp/ax7z_src-orig/7z/7zip/Bundles/ax7z/ExtractCallback.h	2005-06-28 22:01:40.000000000 +0900
+++ ./7z/7zip/Bundles/ax7z/ExtractCallback.h	2015-01-09 00:41:22.357849400 +0900
@@ -5,13 +5,16 @@
 #ifndef __EXTRACTCALLBACK_H
 #define __EXTRACTCALLBACK_H
 
-#include "Common/String.h"
+//#include "Common/String.h"
 #include "../../Common/FileStreams.h"
 #include "../../IPassword.h"
 #include "../../Archive/IArchive.h"
 #include "../../UI/Common/ZipRegistry.h"
 #include <stdio.h>
 
+#include "entryFuncs.h"
+#include "SolidCache.h"
+
 class CExtractCallbackImp: 
   public IArchiveExtractCallback,
   public ICryptoGetTextPassword,
@@ -39,13 +42,18 @@
 
   bool IsEncrypted(UINT32 index);
 public:
-  void Init(IInArchive *archive, char* pBuf, UINT32 nBufSize, FILE* fp, UINT32 index);
+  void Init(IInArchive *archive, char** pBuf, UINT32 nBufSize, FILE* fp, UINT32 index, SolidFileCache *cache, SPI_PROGRESS lpPrgressCallback, long lData);
 
   UINT64 m_NumErrors;
-  char* m_pBuf;
+private:
+  char** m_pBuf;
   FILE* m_fp;
   UINT32 m_nBufSize;
   UINT32 m_nIndex;
+  UINT32 m_nCurIndex;
+  SolidFileCache *m_cache;
+  SPI_PROGRESS m_lpPrgressCallback;
+  long m_lData;
 };
 
 #endif
diff -urN -X diff-exclude.txt /var/tmp/ax7z_src-orig/7z/7zip/Bundles/ax7z/Lock.h ./7z/7zip/Bundles/ax7z/Lock.h
--- /var/tmp/ax7z_src-orig/7z/7zip/Bundles/ax7z/Lock.h	1970-01-01 09:00:00.000000000 +0900
+++ ./7z/7zip/Bundles/ax7z/Lock.h	2015-01-09 00:41:22.360849700 +0900
@@ -0,0 +1,45 @@
+#define N BOOST_PP_ITERATION()
+
+#define VAR_TN BOOST_PP_ENUM_PARAMS(N, t)
+#if   BOOST_PP_ITERATION_FLAGS() == 1
+#define ARG_(z, n, data) typename boost::call_traits<typename boost::mpl::at<boost::function_types::parameter_types<Method>, boost::mpl::int_<n+1> >::type>::param_type BOOST_PP_CAT(t, n)
+#elif BOOST_PP_ITERATION_FLAGS() == 2
+#define ARG_(z, n, data) typename boost::call_traits<typename boost::mpl::at<boost::function_types::parameter_types<Method>, boost::mpl::long_<n+1> >::type>::param_type BOOST_PP_CAT(t, n)
+#elif BOOST_PP_ITERATION_FLAGS() == 3
+#define ARG_(z, n, data) typename boost::call_traits<typename boost::mpl::at_c<boost::function_types::parameter_types<Method>, n+1>::type>::param_type BOOST_PP_CAT(t, n)
+#endif
+#define ARG_N BOOST_PP_ENUM_TRAILING(N, ARG_, _)
+
+	template<typename Method>
+	typename boost::enable_if_c<boost::function_types::function_arity<Method>::value == N + 1, typename boost::function_types::result_type<Method>::type>::type
+	CallWithLockGuard(Method m /*,*/ ARG_N)
+	{
+		boost::lock_guard<SolidCache::Mutex> guard(SolidCache::GetMutex());
+		return (this->*m)(VAR_TN);
+	}
+	template<typename Method>
+	typename boost::enable_if_c<boost::function_types::function_arity<Method>::value == N + 1, typename boost::function_types::result_type<Method>::type>::type
+	CallWithLockGuard(Method m /*,*/ ARG_N) const
+	{
+		boost::lock_guard<SolidCache::Mutex> guard(SolidCache::GetMutex());
+		return (this->*m)(VAR_TN);
+	}
+	template<typename Method>
+	typename boost::enable_if_c<boost::function_types::function_arity<Method>::value == N + 1, typename boost::function_types::result_type<Method>::type>::type
+	CallWithSharedLock(Method m /*,*/ ARG_N)
+	{
+		boost::shared_lock<SolidCache::Mutex> guard(SolidCache::GetMutex());
+		return (this->*m)(VAR_TN);
+	}
+	template<typename Method>
+	typename boost::enable_if_c<boost::function_types::function_arity<Method>::value == N + 1, typename boost::function_types::result_type<Method>::type>::type
+	CallWithSharedLock(Method m /*,*/ ARG_N) const
+	{
+		boost::shared_lock<SolidCache::Mutex> guard(SolidCache::GetMutex());
+		return (this->*m)(VAR_TN);
+	}
+
+#undef ARG_N
+#undef ARG_
+#undef VAR_TN
+#undef N
diff -urN -X diff-exclude.txt /var/tmp/ax7z_src-orig/7z/7zip/Bundles/ax7z/OpenCallback.cpp ./7z/7zip/Bundles/ax7z/OpenCallback.cpp
--- /var/tmp/ax7z_src-orig/7z/7zip/Bundles/ax7z/OpenCallback.cpp	2005-06-21 21:50:12.000000000 +0900
+++ ./7z/7zip/Bundles/ax7z/OpenCallback.cpp	2013-04-12 00:17:01.659373300 +0900
@@ -1,6 +1,7 @@
 // OpenCallback.cpp
 #include <windows.h>
 #include "OpenCallback.h"
+#include "PasswordManager.h"
 
 #include "Common/StdOutStream.h"
 #include "Common/StdInStream.h"
@@ -70,17 +71,10 @@
 
 STDMETHODIMP COpenCallbackImp2::CryptoGetTextPassword(BSTR *password)
 {
-    /*
-    if (!PasswordIsDefined)
-    {
-    g_StdOut << "\nEnter password:";
-    AString oemPassword = g_StdIn.ScanStringUntilNewLine();
-    Password = MultiByteToUnicodeString(oemPassword, CP_OEMCP); 
-    PasswordIsDefined = true;
-    }
-    CMyComBSTR temp(Password);
+	UString usPassword = PasswordManager::Get().GetPassword(true);
+	CMyComBSTR temp(usPassword);
     *password = temp.Detach();
-    */
+
     return S_OK;
 }
 
diff -urN -X diff-exclude.txt /var/tmp/ax7z_src-orig/7z/7zip/Bundles/ax7z/OpenCallback.h ./7z/7zip/Bundles/ax7z/OpenCallback.h
--- /var/tmp/ax7z_src-orig/7z/7zip/Bundles/ax7z/OpenCallback.h	2005-06-21 21:50:12.000000000 +0900
+++ ./7z/7zip/Bundles/ax7z/OpenCallback.h	2013-04-12 00:17:01.661373500 +0900
@@ -5,7 +5,7 @@
 #ifndef __OPENCALLBACK_H
 #define __OPENCALLBACK_H
 
-#include "Common/String.h"
+//#include "Common/String.h"
 #include "Common/MyCom.h"
 #include "Windows/FileFind.h"
 
@@ -38,9 +38,7 @@
   UString _folderPrefix;
   NWindows::NFile::NFind::CFileInfoW _fileInfo;
 public:
-  bool PasswordIsDefined;
-  UString Password;
-  COpenCallbackImp2(): PasswordIsDefined(false) {}
+  COpenCallbackImp2() {}
   void LoadFileInfo(const UString &folderPrefix,  const UString &fileName)
   {
     _folderPrefix = folderPrefix;
diff -urN -X diff-exclude.txt /var/tmp/ax7z_src-orig/7z/7zip/Bundles/ax7z/PasswordManager.cpp ./7z/7zip/Bundles/ax7z/PasswordManager.cpp
--- /var/tmp/ax7z_src-orig/7z/7zip/Bundles/ax7z/PasswordManager.cpp	1970-01-01 09:00:00.000000000 +0900
+++ ./7z/7zip/Bundles/ax7z/PasswordManager.cpp	2013-04-12 00:17:01.663373700 +0900
@@ -0,0 +1,152 @@
+//PasswordManager.cpp
+#include "PasswordManager.h"
+#include "../../../Common/StringConvert.h"
+#include "resource.h"
+
+PasswordManager& PasswordManager::Get()
+{
+	static PasswordManager pm;
+	return pm;
+}
+
+const UString& PasswordManager::GetPassword(bool bFilename)
+{
+	extern HINSTANCE g_hInstance;
+	m_bFilename = bFilename;
+	if(IsRetry()) {
+		m_bPassword = false;
+	}
+	if(!m_bPassword && !m_bSkip && !m_bSkipArc) {
+		DialogBoxParam(g_hInstance, MAKEINTRESOURCE(IDD_PASSWORD), NULL, (DLGPROC)PasswordDlgProc, reinterpret_cast<LPARAM>(static_cast<void*>(this)));
+		m_bError = false;
+	}
+	if(!m_bPassword) {
+		m_usPassword = L"";
+	}
+	m_bPasswordUsed = true;
+	return m_usPassword;
+}
+
+bool PasswordManager::IsRetry() const
+{
+	return m_bPasswordUsed && m_bError && !m_bSkip && !m_bSkipArc;
+}
+
+bool PasswordManager::IsValid() const
+{
+	return !m_bArchiveChanged && !m_bError && !m_bSkip && !m_bSkipArc;
+}
+
+void PasswordManager::NotifyArchive(const UString& usArchive)
+{
+	if(m_usArchive != usArchive) {
+		m_bPasswordUsed = false;
+		m_bArchiveChanged = true;
+		m_bError = false;
+		m_bSkip = false;
+		m_bSkipArc = false;
+		m_usArchive = usArchive;
+	}
+}
+
+void PasswordManager::NotfiyEndFile()
+{
+	m_bPasswordUsed = false;
+	m_bError = false;
+	m_bSkip = false;
+}
+
+void PasswordManager::NotifyError()
+{
+	m_bError = true;
+}
+
+void PasswordManager::ClearError()
+{
+	m_bError = false;
+}
+
+void PasswordManager::Reset()
+{
+	m_bPassword = false;
+}
+
+INT_PTR CALLBACK PasswordManager::PasswordDlgProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
+{
+	switch(uMsg)
+	{
+	case WM_INITDIALOG:
+	{
+		SetWindowLongPtr(hwnd, DWLP_USER, lParam);
+		PasswordManager* p = static_cast<PasswordManager*>(reinterpret_cast<void*>(GetWindowLongPtr(hwnd, DWLP_USER)));
+		if(p->m_bFilename) EnableWindow(GetDlgItem(hwnd, IDC_SKIP_BUTTON), FALSE);
+		if(p->IsRetry()) SetWindowText(GetDlgItem(hwnd, IDC_GUIDE_STATIC), "Extract error, maybe caused by wrong password,\nretype password:");
+		HMENU hSysMenu = GetSystemMenu(hwnd, FALSE);
+		InsertMenu(hSysMenu, SC_CLOSE, MF_STRING | (p->m_bTopMost ? MF_CHECKED : 0), IDM_TOPMOST, TEXT("TopMost"));
+		InsertMenu(hSysMenu, SC_CLOSE, MF_SEPARATOR, 0, 0);
+		if(p->m_bTopMost) {
+			SetWindowPos(hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
+		} else {
+			SetWindowPos(hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
+		}
+		return TRUE;
+	}
+	case WM_INITMENUPOPUP:
+	{
+		HMENU hSysMenu = GetSystemMenu(hwnd, FALSE);
+		if(hSysMenu == static_cast<HANDLE>(reinterpret_cast<void*>(wParam))) {
+			PasswordManager* p = static_cast<PasswordManager*>(reinterpret_cast<void*>(GetWindowLongPtr(hwnd, DWLP_USER)));
+			ModifyMenu(hSysMenu, IDM_TOPMOST, MF_BYCOMMAND | MF_STRING | (p->m_bTopMost ? MF_CHECKED : 0), IDM_TOPMOST, TEXT("TopMost"));
+		}
+		return TRUE;
+	}
+	case WM_SYSCOMMAND:
+		if((wParam & 0xFFF0) == IDM_TOPMOST) {
+			PasswordManager* p = static_cast<PasswordManager*>(reinterpret_cast<void*>(GetWindowLongPtr(hwnd, DWLP_USER)));
+			p->m_bTopMost = !p->m_bTopMost;
+			if(p->m_bTopMost) {
+				SetWindowPos(hwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
+			} else {
+				SetWindowPos(hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
+			}
+			return TRUE;
+		}
+		return FALSE;
+	case WM_COMMAND:
+		switch(LOWORD(wParam)) {
+		case IDOK:
+		{
+			PasswordManager* p = static_cast<PasswordManager*>(reinterpret_cast<void*>(GetWindowLongPtr(hwnd, DWLP_USER)));
+			char buf[4096+1];
+			GetDlgItemText(hwnd, IDC_PASSWORD_EDIT, buf, sizeof(buf));
+			AString oemPassword = buf;
+			p->m_usPassword = MultiByteToUnicodeString(oemPassword, CP_OEMCP);
+			p->m_bPassword = true;
+			p->m_bArchiveChanged = false;
+			EndDialog(hwnd, TRUE);
+			break;
+		}
+		case IDC_SKIP_BUTTON:
+		{
+			PasswordManager* p = static_cast<PasswordManager*>(reinterpret_cast<void*>(GetWindowLongPtr(hwnd, DWLP_USER)));
+			p->m_bSkip = true;
+			p->m_bPassword = false;
+			EndDialog(hwnd, FALSE);
+			break;
+		}
+		case IDC_SKIPARC_BUTTON:
+		{
+			PasswordManager* p = static_cast<PasswordManager*>(reinterpret_cast<void*>(GetWindowLongPtr(hwnd, DWLP_USER)));
+			p->m_bSkipArc = true;
+			p->m_bPassword = false;
+			EndDialog(hwnd, FALSE);
+			break;
+		}
+		default:
+			return FALSE;
+		}
+	default:
+		return FALSE;
+	}
+	return FALSE; // not reached
+}
\ No newline at end of file
diff -urN -X diff-exclude.txt /var/tmp/ax7z_src-orig/7z/7zip/Bundles/ax7z/PasswordManager.h ./7z/7zip/Bundles/ax7z/PasswordManager.h
--- /var/tmp/ax7z_src-orig/7z/7zip/Bundles/ax7z/PasswordManager.h	1970-01-01 09:00:00.000000000 +0900
+++ ./7z/7zip/Bundles/ax7z/PasswordManager.h	2013-04-12 00:17:01.665373900 +0900
@@ -0,0 +1,45 @@
+//PasswordManager.h
+
+#pragma once
+
+#ifndef PASSWORDMANAGER_H
+#define PASSWORDMANAGER_H
+
+#include "../../../Common/MyString.h"
+
+class PasswordManager
+{
+public:
+	static PasswordManager& Get();
+	bool IsRetry() const;
+	bool IsDefined() const { return m_bPassword; }
+	bool IsValid() const;
+	const UString& GetPassword(bool bFilename);
+	void NotifyArchive(const UString& usArchive);
+	void NotfiyEndFile();
+	void NotifyError();
+	void ClearError();
+	void Reset();
+	bool SetTopMost(bool flag)
+	{
+		bool bPrev = m_bTopMost;
+		m_bTopMost = flag;
+		return bPrev;
+	}
+	bool GetTopMost() const { return m_bTopMost; }
+private:
+	static INT_PTR CALLBACK PasswordDlgProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
+	PasswordManager() : m_bPassword(false), m_bPasswordUsed(false), m_bArchiveChanged(false), m_bError(false), m_bSkip(false), m_bSkipArc(false) {}
+	bool m_bPassword;
+	bool m_bPasswordUsed;
+	bool m_bArchiveChanged;
+	bool m_bError;
+	bool m_bFilename;
+	bool m_bSkip;
+	bool m_bSkipArc;
+	bool m_bTopMost;
+	UString m_usPassword;
+	UString m_usArchive;
+};
+
+#endif
diff -urN -X diff-exclude.txt /var/tmp/ax7z_src-orig/7z/7zip/Bundles/ax7z/SolidArchiveExtractCallback.cpp ./7z/7zip/Bundles/ax7z/SolidArchiveExtractCallback.cpp
--- /var/tmp/ax7z_src-orig/7z/7zip/Bundles/ax7z/SolidArchiveExtractCallback.cpp	2005-09-26 02:36:18.000000000 +0900
+++ ./7z/7zip/Bundles/ax7z/SolidArchiveExtractCallback.cpp	2015-01-09 00:41:22.363850000 +0900
@@ -1,6 +1,7 @@
 // SolidArchiveExtractCallback.h
 #include <windows.h>
 #include "SolidArchiveExtractCallback.h"
+#include "PasswordManager.h"
 #include "Common/StringConvert.h"
 #include "Windows/FileDir.h"
 #include "Windows/PropVariant.h"
@@ -110,27 +111,25 @@
     {
       break;
     }
+    case NArchive::NExtract::NOperationResult::kDataError:
+    case NArchive::NExtract::NOperationResult::kCRCError:
+    {
+      PasswordManager::Get().NotifyError();
+    }
     default:
     {
       m_NumErrors++;
     }
   }
+  PasswordManager::Get().NotfiyEndFile();
   return S_OK;
 }
 
 STDMETHODIMP CSolidArchiveExtractCallbackImp::CryptoGetTextPassword(BSTR *password)
 {
-  /*
-  if (!m_PasswordIsDefined)
-  {
-    g_StdOut << "\nEnter password:";
-    AString oemPassword = g_StdIn.ScanStringUntilNewLine();
-    m_Password = MultiByteToUnicodeString(oemPassword, CP_OEMCP); 
-    m_PasswordIsDefined = true;
-  }
-  CMyComBSTR tempName(m_Password);
+  UString usPassword = PasswordManager::Get().GetPassword(false);
+  CMyComBSTR tempName(usPassword);
   *password = tempName.Detach();
-  */
   return S_OK;
 }
   
diff -urN -X diff-exclude.txt /var/tmp/ax7z_src-orig/7z/7zip/Bundles/ax7z/SolidArchiveExtractCallback.h ./7z/7zip/Bundles/ax7z/SolidArchiveExtractCallback.h
--- /var/tmp/ax7z_src-orig/7z/7zip/Bundles/ax7z/SolidArchiveExtractCallback.h	2005-09-26 02:36:38.000000000 +0900
+++ ./7z/7zip/Bundles/ax7z/SolidArchiveExtractCallback.h	2013-04-12 00:17:01.667374100 +0900
@@ -5,7 +5,7 @@
 #ifndef __SOLIDARCHIVEEXTRACTCALLBACK_H
 #define __SOLIDARCHIVEEXTRACTCALLBACK_H
 
-#include "Common/String.h"
+//#include "Common/String.h"
 #include "../../Common/FileStreams.h"
 #include "../../IPassword.h"
 #include "../../Archive/IArchive.h"
